<?php
/*
	Attachments2 rules wizard.
	By Dexus (volutar@mail.ru)
	24 apr 2005

*/
define('PUN_ROOT', './');
require PUN_ROOT.'include/common.php';
require PUN_ROOT.'include/common_admin.php';
require PUN_ROOT.'include/attach/attach_incl.php';

if ($pun_user['g_id'] > PUN_MOD)
	message($lang_common['No permission']);

if (isset($_POST['form_sent']))
{
	confirm_referrer('attach_rulwiz.php');

	$result = $db->query('
	DELETE FROM '.$db->prefix.'attach_2_rules')
	or error('Unable to clear groups',__FILE__,__LINE__,$db->error());
        $ii=0;

$result2 = $db->query('
SELECT g_id,g_title
FROM '.$db->prefix.'groups
WHERE g_id>1
ORDER BY g_id')
or error('Unable to fetch groups',__FILE__,__LINE__,$db->error());
while(list($g_id,$g_title) = $db->fetch_row($result2))
	$groups_ids[]=$g_id;

$result1 = $db->query('
SELECT id,forum_name
FROM '.$db->prefix.'forums
ORDER BY cat_id,id')
or error('Unable to fetch forums',__FILE__,__LINE__,$db->error());

while(list($f_id,$f_name) = $db->fetch_row($result1)){
	foreach ($groups_ids as $gid) {
		$fid=$f_id;
		$r_size= isset($_POST['c_'.$gid.'_'.$fid.'_size'])?intval($_POST['c_'.$gid.'_'.$fid.'_size']):0;
		$r_rules=0;
		$r_rules+=ATTACH_DOWNLOAD*(isset($_POST['c_'.$gid.'_'.$fid.'_down'])?intval($_POST['c_'.$gid.'_'.$fid.'_down']):0);
		$r_rules+=ATTACH_UPLOAD*(isset($_POST['c_'.$gid.'_'.$fid.'_up'])?intval($_POST['c_'.$gid.'_'.$fid.'_up']):0);
		$r_rules+=ATTACH_OWNER_DELETE*(isset($_POST['c_'.$gid.'_'.$fid.'_own'])?intval($_POST['c_'.$gid.'_'.$fid.'_own']):0);
		$r_rules+=ATTACH_DELETE*(isset($_POST['c_'.$gid.'_'.$fid.'_del'])?intval($_POST['c_'.$gid.'_'.$fid.'_del']):0);
		$r_perpost= isset($_POST['c_'.$gid.'_'.$fid.'_pp'])?intval($_POST['c_'.$gid.'_'.$fid.'_pp']):0;
		$r_ext= pun_trim($_POST['c_'.$gid.'_'.$fid.'_ext'])?pun_trim($_POST['c_'.$gid.'_'.$fid.'_ext']):'';

		if ($r_rules==0 && $r_size==0 && $r_perpost==0 && $r_ext=='')
		{}
		else
		$db->query('
INSERT INTO '.$db->prefix.'attach_2_rules
(id, forum_id, group_id, rules, size, per_post, file_ext)
VALUES
('.++$ii.',
'.$fid.',
'.$gid.',
\''.$r_rules.'\',
\''.$r_size.'\',
\''.$r_perpost.'\',
\''.$db->escape($r_ext).'\')') or error('Unable to create post', __FILE__, __LINE__, $db->error());
		}
	}
	redirect('attach_rulwiz.php', "Attachment rules updated");
}

$page_title = 'Attachments rules wizard';
require PUN_ROOT.'header.php';

?>
<form id="post" method="post" action="attach_rulwiz.php">
<div class="blocktable">
<div class="box">
<div class="inbox">
<h2>Attachments rules wizard</h2>
<div class="scrollbox">
<table cellspacing="0" style="table-layout:fixed">
<tr><th width="150px">&nbsp;</th>
<?php
$result2 = $db->query('
SELECT g_id,g_title
FROM '.$db->prefix.'groups
WHERE g_id>1
ORDER BY g_id')
or error('Unable to fetch groups',__FILE__,__LINE__,$db->error());

while(list($g_id,$g_title) = $db->fetch_row($result2)){
	echo "<th width=\"200px\"><b>$g_title</b> \n";
	echo '<a href="javascript:cg(\''.$g_id.'\')">copy</a>'."\n";
	echo '<a href="javascript:pg(\''.$g_id.'\')">paste</a>'."\n";
	echo "</th>\n";
	$groups_ids[]=$g_id;
}

echo "</tr>\n";

$last_cat='';

$result1 = $db->query('
SELECT f.id,f.forum_name,
c.cat_name
FROM '.$db->prefix.'forums f
INNER JOIN
'.$db->prefix.'categories c
ON c.id=f.cat_id
ORDER BY f.cat_id DESC')
or error('Unable to fetch forums',__FILE__,__LINE__,$db->error());

while(list($f_id,$f_name,$f_cat) = $db->fetch_row($result1)){
if ($last_cat!=$f_cat) {
$last_cat=$f_cat;
echo "<tr><th><h2>".$f_cat."</h2></th><th colspan=\"".(count($groups_ids))."\">";
echo "</th></tr>\n";
}

$forums_ids[]=$f_id;
echo "<tr><th>$f_name\n";
echo '<br /><a href="javascript:cf(\''.$f_id.'\')">copy</a>'."\n";
echo '<a href="javascript:pf(\''.$f_id.'\')">paste</a>'."\n";
echo "</th>\n";

$result2 = $db->query('
SELECT g_id,g_title
FROM '.$db->prefix.'groups
WHERE g_id>1
ORDER BY g_id')
or error('Unable to fetch groups',__FILE__,__LINE__,$db->error());

while(list($g_id,$g_title) = $db->fetch_row($result2)){

$res_rul = $db->query('
SELECT rules, size, per_post, file_ext
FROM '.$db->prefix.'attach_2_rules
WHERE forum_id='.$f_id.' AND group_id='.$g_id)
or error('Unable to fetch rights for users',__FILE__,__LINE__,$db->error());

if($db->num_rows($res_rul)!=0){
	list($r_rules,$r_size,$r_per_post,$r_file_ext) = $db->fetch_row($res_rul);
	echo "<td>";
}
else {
	$r_rules=0; $r_size=0; $r_per_post=0; $r_file_ext='';
	echo "<td id=\"brdmenu\">";
}

$check ='<input type="checkbox" class="c" name="c_'.$g_id.'_'.$f_id.'_down" value="1" ';
$check.= (attach_rules($r_rules,ATTACH_DOWNLOAD))?'checked="checked" ':'';
$check.=" />down \n";
$check.='<input type="checkbox" class="c" name="c_'.$g_id.'_'.$f_id.'_up" value="1" ';
$check.= (attach_rules($r_rules,ATTACH_UPLOAD))?'checked="checked" ':'';
$check.=" />up \n";
$check.='<input type="checkbox" class="c" name="c_'.$g_id.'_'.$f_id.'_own" value="1" ';
$check.= (attach_rules($r_rules,ATTACH_OWNER_DELETE))?'checked="checked" ':'';
$check.=" />own \n";
$check.='<input type="checkbox" class="c" name="c_'.$g_id.'_'.$f_id.'_del" value="1" ';
$check.= (attach_rules($r_rules,ATTACH_DELETE))?'checked="checked" ':'';
$check.=" />del\n";

$check.="<br />Max:";
$check.='<input type="text" size=10 name="c_'.$g_id.'_'.$f_id.'_size" value="'.$r_size.'" />bytes '."\n";
$check.='<input type="text" size=2 name="c_'.$g_id.'_'.$f_id.'_pp" value="'.$r_per_post.'" />files '."\n";
$check.='<input type="text" name="c_'.$g_id.'_'.$f_id.'_ext" value="'.$r_file_ext.'" />ext '."\n";
$check.='<br /><a href="javascript:cc(\''.$g_id.'_'.$f_id.'\')">copy</a>'."\n";
$check.='<a href="javascript:pc(\''.$g_id.'_'.$f_id.'\')">paste</a>'."\n";
$check.='<a href="javascript:ccc(\''.$g_id.'_'.$f_id.'\')">del</a>'."\n";

	echo "$check</td>\n";
}
echo "</tr>\n";
}

?>
</table></div>
</div></div>
<input type="submit" name="submit" value="Update rules" />
<input type="hidden" name="form_sent" value="1" />
</div>
</form>

<script type="text/javascript">

var cell_id=''; var group_id=''; var forum_id='';

forums_ids=[<?php
foreach ($forums_ids as $key => $value) {
	echo $value;
	if ($key<count($forums_ids)-1) echo ",";
}
?>];
groups_ids=[<?php
foreach ($groups_ids as $key => $value) {
	echo $value;
	if ($key<count($groups_ids)-1) echo ",";
}
?>];

function pg(p_id){
	for (c=0; c<forums_ids.length; ++c) {
		pcc(group_id+'_'+forums_ids[c], p_id+'_'+forums_ids[c]);
	}
}

function pf(p_id){
	for (c=0; c<groups_ids.length; ++c) {
		pcc(groups_ids[c]+'_'+forum_id, groups_ids[c]+'_'+p_id);
	}
}

function pc(p_id){
	if (cell_id=='') return;
	pcc(cell_id,p_id);
}

function cg(p_id){ group_id=p_id;}
function cf(p_id){ forum_id=p_id;}
function cc(p_id){ cell_id=p_id;}

function pcc(c_id,p_id){
	msgf = document.forms[0]['c_'+c_id+'_down'];
	document.forms[0]['c_'+p_id+'_down'].checked = msgf.checked;
	msgf = document.forms[0]['c_'+c_id+'_up'];
	document.forms[0]['c_'+p_id+'_up'].checked = msgf.checked;
	msgf = document.forms[0]['c_'+c_id+'_own'];
	document.forms[0]['c_'+p_id+'_own'].checked = msgf.checked;
	msgf = document.forms[0]['c_'+c_id+'_del'];
	document.forms[0]['c_'+p_id+'_del'].checked = msgf.checked;

	msgf = document.forms[0]['c_'+c_id+'_size'];
	document.forms[0]['c_'+p_id+'_size'].value = msgf.value;
	msgf = document.forms[0]['c_'+c_id+'_pp'];
	document.forms[0]['c_'+p_id+'_pp'].value = msgf.value;
	msgf = document.forms[0]['c_'+c_id+'_ext'];
	document.forms[0]['c_'+p_id+'_ext'].value = msgf.value;
}
function ccc(p_id){
	document.forms[0]['c_'+p_id+'_down'].checked = '';
	document.forms[0]['c_'+p_id+'_up'].checked = '';
	document.forms[0]['c_'+p_id+'_own'].checked = '';
	document.forms[0]['c_'+p_id+'_del'].checked = '';

	document.forms[0]['c_'+p_id+'_size'].value = '';
	document.forms[0]['c_'+p_id+'_pp'].value = '';
	document.forms[0]['c_'+p_id+'_ext'].value = '';
}
</script>
<?php
require PUN_ROOT.'footer.php';
